<?
	require_once('LWZfunctions.ips.php');
	$lwzdata = LWZ_UnEscape($_IPS['VALUE']);

	if($lwzdata == chr(0x02)) {
		LWZ_Ack();
	} elseif (substr($lwzdata,0,2) == chr(0x01).chr(0x05)) {
		IPS_LogMessage("LWZ","Error: " . LWZ_strToHex($lwzdata));
	} elseif ($lwzdata == chr(0x10)) {
		// Ack from Device. Discard
	   pi();
	} elseif((strlen($lwzdata) > 4) and LWZ_VerifyChecksum($lwzdata) ){
		$command = substr($lwzdata,3,1);
		
		// Actual Values
		if($command == chr(0xFB)) {
			$data = LWZ_GetActualValues($lwzdata);
			SetValueFloat(17793 , $data["FlowTemperature"]);
			SetValueFloat(23464 , $data["ReturnTemperature"]);
			SetValueFloat(21407 , $data["HotGas"]);
			SetValueFloat(44050 , $data["DHWTemperature"]);
			// SetValueFloat(not used, $data["FlowHC2Temperature"]);
			SetValueFloat(44289 , $data["InsideTemperature"]);
			SetValueFloat(19774 , $data["EvaporatorTemperature"]);
			SetValueFloat(21738 , $data["CondenserTemperature"]);
			SetValueInteger(29927 , $data["ExtractorSpeedSet"]);
			SetValueInteger(24242 , $data["VentilatorSpeedSet"]);
			SetValueInteger(33612 , $data["ExpelledAirSpeedSet"]);
			SetValueInteger(16723 , $data["ExtractorSpeedActual"]);
			SetValueInteger(29604 , $data["VentilatorSpeedActual"]);
			SetValueInteger(14614 , $data["ExpelledAirSpeedActual"]);
			SetValueFloat(28743 , $data["OutsideTemperature"]);
			//SetValueFloat(not used, $data["RelativeHumidity"]);
			SetValueBoolean(30269  , $data["DHW_Pump"]);
			SetValueBoolean(37889  , $data["HeatingCircuit_Pump"]);
			//SetValueBoolean(not used , $data["Solar_Pump"]);
			SetValueBoolean(41792  , $data["MixerOpen"]);
			SetValueBoolean(20916  , $data["MixerClosed"]);
			SetValueBoolean(28812  , $data["HeatPipeValve"]);
			SetValueBoolean(13655  , $data["DiverterValve"]);
			SetValueBoolean(51157  , $data["Compressor"]);
			SetValueBoolean(43869  , $data["BoosterStage3"]);
			SetValueBoolean(43321  , $data["BoosterStage2"]);
			SetValueBoolean(34699  , $data["BoosterStage1"]);
			SetValueBoolean(44948  , $data["HighPressureSensor"]);
			SetValueBoolean(40021  , $data["LowPressureSensor"]);
			SetValueBoolean(31361  , $data["EvaporatorIceMonitor"]);
			SetValueBoolean(14592  , $data["SignalAnode"]);
			//SetValueBoolean(not used , $data["EVU_release"]);
			//SetValueBoolean(not used , $data["OvenFireplace"]);
			SetValueBoolean(59716  , $data["STB"]);
			SetValueFloat(32092  , $data["OutsideTemperatureFiltered"]);
		}

		// Heat Values
		if($command == chr(0xF4)) {
			$data = LWZ_GetHeatValues($lwzdata);
			SetValueFloat(25871  , $data["IntegralHeat"]);
			SetValueFloat(45640  , $data["HeatSetTemperature"]);
			SetValueFloat(42709  , $data["HeatTemperature"]);
			SetValueInteger(35290  , $data["Mode"]);
			SetValueInteger(21660  , $data["IntegralSwitch"]);
			SetValueFloat(10868  , $data["RoomSetTemperature"]);
		}
		
		// Version
		if($command == chr(0xFD)) {
			IPS_LogMessage("LWZ", "LWZ Version: " . LWZ_GetVersion($lwzdata));
		}

		if($command = chr(0x0A)) {  // Switch to Multibyte Commands
			$command = substr($lwzdata,3,3);

			// Operating Mode
			if($command == chr(0x0A).chr(0x01).chr(0x12)) {
				SetValueInteger(57648 ,LWZ_GetOperatingMode($lwzdata));
			}

			// Passive Cooling
			if($command == chr(0x0A).chr(0x05).chr(0x75)) {
				SetValueInteger(18860 ,LWZ_GetPassiveCooling($lwzdata));
			}

		}


  } else {
	  IPS_LogMessage("LWZ",	"Unknown or corupt data: " . LWZ_strToHex($lwzdata));
  }


?>
